//
// Created by william on 10/01/24.
//

#ifndef NESEMULATOR_PROGRAM_VIEW_H
#define NESEMULATOR_PROGRAM_VIEW_H

#include <panel.h>
#include "../include/types.h"
#include "../cpu/decoding.h"
#include "cursor.h"
#include "window.h"

#define PROGRAM_VIEW_HEIGHT 19
#define PROGRAM_VIEW_WIDTH 42

typedef struct program_view {
    InteractWindow *window;
    byte *ram;
    address base_address;
} ProgramView;

typedef struct debug_operand {
    address addr;
    byte op_code;
    AddressingMode addr_mode;
    enum OperandType type;
    word value;
} DebugOperand;

void program_view_init(InteractWindow *interact, ram ram, int x, int y);

#endif //NESEMULATOR_PROGRAM_VIEW_H